/*
 * $Id: active_probing.h,v 1.3 2001/07/20 22:55:23 laik Exp $
 *
 * This file contains information about the active probing routines.
 *
 * Copyright (C) 1998 Kevin Lai
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __ACTIVE_PROBING_H__
#define __ACTIVE_PROBING_H__

#include "dpcap_flow.h"

#include "kl_event.h"
#include "kl_list.h"
#include "kl_buffered_output.h"

#include "transport.h"
#include "flow_calc.h"

struct ActiveProbing;
typedef struct ActiveProbing ActiveProbing;

typedef struct ActiveProbingDef {
    KLEventManager *manager;  
    TransportFlow flow;
    struct timespec timeout;
    unsigned int burst_size;
    unsigned int packet_size;
    unsigned int min_samples;
    unsigned int max_packets_sent;
    double max_error;
} ActiveProbingDef;

KLExceptionClass active_probing_below_max_error_ec;

ActiveProbing *
active_probing_new(ActiveProbingDef *def);

void
active_probing_free(ActiveProbing *ap);

KLException *
active_probing_start(ActiveProbing *ap);

KLException *
active_probing_packet_new(
    FlowCalcFlow *flow, const KLListNode *cur_node, int timer_index,
    int ack, void *flow_set_client_data);

#endif


