/*
 * $Id: lbc_tailgate.h,v 1.2 2000/10/10 22:39:57 laik Exp $
 *
 * This file contains information necessary to use the link bandwidth
 * calculation routines in tailgate mode.
 *
 * Copyright (C) 1998 Kevin Lai
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LBC_TAILGATE_H__
#define __LBC_TAILGATE_H__

#include "kl_array.h"

#include "dpcap_flow.h"

#include "transport.h"

struct LBCTailgate;
typedef struct LBCTailgate LBCTailgate;

typedef struct LBCTailgateDef {
    TransportFlow flow;
    unsigned int min_packets;
    unsigned int max_bootstrap_sample_size;
    unsigned int bootstrap_iterations;
} LBCTailgateDef;

LBCTailgate *
lbc_tailgate_new(LBCTailgateDef *def);

void
lbc_tailgate_free(LBCTailgate *lbc_tailgate);

unsigned int
lbc_tailgate_send_packet(LBCTailgate *lbc_tailgate);

void
lbc_links_get_string(
    LBCTailgate *lbc_tailgate, double sigma_slope, double sigma_intercept,
    KLArray *array);

void
lbc_tailgate_get_max_error(LBCTailgate *lbc_tailgate, double *error);

int
lbc_tailgate_sample_received(
    LBCTailgate *lbc_tailgate, const DPCapFlowPacket *packet, 
    const struct timespec *delay, unsigned int timing_type);

#endif


